package org.aiwolf.IOH;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class Parameters {
	List<Params> params = new ArrayList<Params>();
	Params werewolf_co_rate;
	Params possessed_co_rate;
	Params werewolf_divined_black;
	Params possessed_divined_black;
	Params trust;
	Params werewolf_taben;
	Params vote_weight;
	Params divine_white_line;  // 占い結果白の時に使用し、どれだけラインを見るかを表す
	Params divine_black_line;  // 占い結果黒の時に使用し、どれだけラインを見るかを表す

	Parameters(int N) {
		if (N == 5) {
			werewolf_co_rate = new Params(0.1, 0, 1, "werewolf_co_rate", 0.3);
			possessed_co_rate = new Params(0.9, 0, 1, "possessed_co_rate", 0.3);
			werewolf_divined_black = new Params(0.5, 0, 1, "werewolf_divined_black", 0.3);
			possessed_divined_black = new Params(0.5, 0, 1, "possessed_divined_black", 0.3);
			trust = new Params(0.6, 0, 1, "trust", 0.3);
			werewolf_taben = new Params(0.0, -1, 1, "werewolf_taben", 0.3);
			vote_weight = new Params(1.0, 0, 10, "vote_weight", 1);
			divine_white_line = new Params(2.0, -10, 10, "divine_white_line", 1); // 実際には5人村では使わない
			divine_black_line = new Params(5.0, -10, 10, "divine_black_line", 1); // 実際には5人村では使わない
		} else {
			werewolf_co_rate = new Params(0.3, 0, 1, "werewolf_co_rate", 0.3);
			possessed_co_rate = new Params(0.9, 0, 1, "possessed_co_rate", 0.3);
			werewolf_divined_black = new Params(0.5, 0, 1, "werewolf_divined_black", 0.3);
			possessed_divined_black = new Params(0.5, 0, 1, "possessed_divined_black", 0.3);
			trust = new Params(0.1, 0, 1, "trust", 0.3);
			werewolf_taben = new Params(0.0, -1, 1, "werewolf_taben", 0.3);
			vote_weight = new Params(10.0, 0, 10, "vote_weight", 1);
			divine_white_line = new Params(2.0, -10, 10, "divine_white_line", 1);
			divine_black_line = new Params(5.0, -10, 10, "divine_black_line", 1);
		}
		params.add(werewolf_co_rate);
		params.add(possessed_co_rate);
		//params.add(werewolf_divined_black);
		//params.add(possessed_divined_black);
		params.add(trust);
		params.add(werewolf_taben);
		params.add(vote_weight);
		params.add(divine_black_line);
		params.add(divine_white_line);
	}

	void transitFrom(Parameters p, Random rnd) {
		copyFrom(p);
		for (int t = 0; t < 1; t++) {
			int i = rnd.nextInt(p.params.size());
			double n = p.params.get(i).value;
			n += p.params.get(i).diff * (2 * rnd.nextDouble() - 1.0);
			n = Math.min(n, p.params.get(i).mx);
			n = Math.max(n, p.params.get(i).mn);
			params.get(i).value = n;
		}
	}

	void copyFrom(Parameters p) {
		for (int i = 0; i < p.params.size(); i++) {
			params.get(i).value = p.params.get(i).value;
		}
	}

	void debug() {
		for (int i = 0; i < params.size(); i++) {
			System.out.println(params.get(i).name + ": " + params.get(i).value);
		}
	}
}
